*$ CREATE MGDRAW.FOR
*COPY MGDRAW
*                                                                      *
*=== mgdraw ===========================================================*
*                                                                      *
      SUBROUTINE MGDRAW ( ICODE, MREG )

      INCLUDE '(DBLPRC)'
      INCLUDE '(DIMPAR)'
      INCLUDE '(IOUNIT)'
*
*----------------------------------------------------------------------*
*                                                                      *
*     Copyright (C) 1990-2013      by        Alfredo Ferrari           *
*     All Rights Reserved.                                             *
*                                                                      *
*                                                                      *
*     MaGnetic field trajectory DRAWing: actually this entry manages   *
*                                        all trajectory dumping for    *
*                                        drawing                       *
*                                                                      *
*     Created on   01 March 1990   by        Alfredo Ferrari           *
*                                              INFN - Milan            *
*     Last change   12-Nov-13      by        Alfredo Ferrari           *
*                                              INFN - Milan            *
*                                                                      *
*----------------------------------------------------------------------*
*
      INCLUDE '(CASLIM)'
      INCLUDE '(COMPUT)'
      INCLUDE '(SOURCM)'
      INCLUDE '(FHEAVY)'
      INCLUDE '(FLKSTK)'
      INCLUDE '(GENSTK)'
      INCLUDE '(MGDDCM)'
      INCLUDE '(PAPROP)'
      INCLUDE '(QUEMGD)'
      INCLUDE '(SUMCOU)'
      INCLUDE '(TRACKR)'
*
      DIMENSION DTQUEN ( MXTRCK, MAXQMG )
*
      CHARACTER*20 FILNAM
      LOGICAL LFCOPE, LFCOPE2
      SAVE LFCOPE, LFCOPE2
      DATA LFCOPE / .FALSE. /
      DATA LFCOPE2 / .FALSE. /
      SAVE T0
*
*----------------------------------------------------------------------*
*                                                                      *
*     Icode = 1: call from Kaskad                                      *
*     Icode = 2: call from Emfsco                                      *
*     Icode = 3: call from Kasneu                                      *
*     Icode = 4: call from Kashea                                      *
*     Icode = 5: call from Kasoph                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
      IF ( .NOT. LFCOPE ) THEN
         LFCOPE = .TRUE.
         IF ( KOMPUT .EQ. 2 ) THEN
            FILNAM = '/'//CFDRAW(1:8)//' DUMP A'
         ELSE
            FILNAM = CFDRAW
         END IF
         OPEN ( UNIT = IODRAW, FILE = FILNAM, STATUS = 'NEW', FORM =
     &          'FORMATTED' )
      END IF
      IF ( JTRACK .EQ. 8 ) THEN
         WRITE (70,*) NCASE, ICODE, LTRACK, T0, SNGL (ATRACK) - T0,
     +        ETRACK - AM(JTRACK)
      ENDIF
 111  FORMAT(I8,I2,I6,3(1X,1PE17.10))   
*  +-------------------------------------------------------------------*
*  |  Quenching is activated
      IF ( LQEMGD ) THEN
         IF ( MTRACK .GT. 0 ) THEN
            RULLL  = ZERZER
            CALL QUENMG ( ICODE, MREG, RULLL, DTQUEN )
            WRITE (IODRAW) ( ( SNGL (DTQUEN (I,JBK)), I = 1, MTRACK ),
     &                         JBK = 1, NQEMGD )
         END IF
      END IF
*  |  End of quenching
*  +-------------------------------------------------------------------*
      RETURN
*
*======================================================================*
*                                                                      *
*     Boundary-(X)crossing DRAWing:                                    *
*                                                                      *
*     Icode = 1x: call from Kaskad                                     *
*             19: boundary crossing                                    *
*     Icode = 2x: call from Emfsco                                     *
*             29: boundary crossing                                    *
*     Icode = 3x: call from Kasneu                                     *
*             39: boundary crossing                                    *
*     Icode = 4x: call from Kashea                                     *
*             49: boundary crossing                                    *
*     Icode = 5x: call from Kasoph                                     *
*             59: boundary crossing                                    *
*                                                                      *
*======================================================================*
*                                                                      *
      ENTRY BXDRAW ( ICODE, MREG, NEWREG, XSCO, YSCO, ZSCO )
      RETURN
*
*======================================================================*
*                                                                      *
*     Event End DRAWing:                                               *
*                                                                      *
*======================================================================*
*                                                                      *
      ENTRY EEDRAW ( ICODE )
      RETURN
*
*======================================================================*
*                                                                      *
*     ENergy deposition DRAWing:                                       *
*                                                                      *
*     Icode = 1x: call from Kaskad                                     *
*             10: elastic interaction recoil                           *
*             11: inelastic interaction recoil                         *
*             12: stopping particle                                    *
*             13: pseudo-neutron deposition                            *
*             14: escape                                               *
*             15: time kill                                            *
*     Icode = 2x: call from Emfsco                                     *
*             20: local energy deposition (i.e. photoelectric)         *
*             21: below threshold, iarg=1                              *
*             22: below threshold, iarg=2                              *
*             23: escape                                               *
*             24: time kill                                            *
*     Icode = 3x: call from Kasneu                                     *
*             30: target recoil                                        *
*             31: below threshold                                      *
*             32: escape                                               *
*             33: time kill                                            *
*     Icode = 4x: call from Kashea                                     *
*             40: escape                                               *
*             41: time kill                                            *
*             42: delta ray stack overflow                             *
*     Icode = 5x: call from Kasoph                                     *
*             50: optical photon absorption                            *
*             51: escape                                               *
*             52: time kill                                            *
*                                                                      *
*======================================================================*
*                                                                      *
      ENTRY ENDRAW ( ICODE, MREG, RULL, XSCO, YSCO, ZSCO )
c$$$      IF ( .NOT. LFCOPE ) THEN
c$$$         LFCOPE = .TRUE.
c$$$         IF ( KOMPUT .EQ. 2 ) THEN
c$$$            FILNAM = '/'//CFDRAW(1:8)//' DUMP A'
c$$$         ELSE
c$$$            FILNAM = CFDRAW
c$$$         END IF
c$$$         OPEN ( UNIT = IODRAW, FILE = FILNAM, STATUS = 'NEW', FORM =
c$$$     &          'UNFORMATTED' )
c$$$      END IF
c$$$      WRITE (IODRAW)  0, ICODE, JTRACK, SNGL (ETRACK), SNGL (WTRACK)
c$$$      WRITE (IODRAW)  SNGL (XSCO), SNGL (YSCO), SNGL (ZSCO), SNGL (RULL)
c$$$*  +-------------------------------------------------------------------*
c$$$*  |  Quenching is activated : calculate quenching factor
c$$$*  |  and store quenched energy in DTQUEN(1, jbk)
c$$$      IF ( LQEMGD ) THEN
c$$$         RULLL = RULL
c$$$         CALL QUENMG ( ICODE, MREG, RULLL, DTQUEN )
c$$$         WRITE (IODRAW) ( SNGL (DTQUEN(1, JBK)), JBK = 1, NQEMGD )
c$$$      END IF
c$$$*  |  end quenching
*  +-------------------------------------------------------------------*
      RETURN
*
*======================================================================*
*                                                                      *
*     SOurce particle DRAWing:                                         *
*                                                                      *
*======================================================================*
*
      ENTRY SODRAW
c$$$      IF ( .NOT. LFCOPE ) THEN
c$$$         LFCOPE = .TRUE.
c$$$         IF ( KOMPUT .EQ. 2 ) THEN
c$$$            FILNAM = '/'//CFDRAW(1:8)//' DUMP A'
c$$$         ELSE
c$$$            FILNAM = CFDRAW
c$$$         END IF
c$$$         OPEN ( UNIT = IODRAW, FILE = FILNAM, STATUS = 'NEW', FORM =
c$$$     &          'UNFORMATTED' )
c$$$      END IF
c$$$      WRITE (IODRAW) -NCASE, NPFLKA, NSTMAX, SNGL (TKESUM),
c$$$     &                SNGL (WEIPRI)
c$$$*  +-------------------------------------------------------------------*
c$$$*  |  (Radioactive) isotope: it works only for 1 source particle on
c$$$*  |  the stack for the time being
c$$$      IF ( ILOFLK (NPFLKA) .GE. 100000 .AND. LRADDC (NPFLKA) ) THEN
c$$$         IARES  = MOD ( ILOFLK (NPFLKA), 100000  )  / 100
c$$$         IZRES  = MOD ( ILOFLK (NPFLKA), 10000000 ) / 100000
c$$$         IISRES = ILOFLK (NPFLKA) / 10000000
c$$$         IONID  = ILOFLK (NPFLKA)
c$$$         WRITE (IODRAW) ( IONID,SNGL(-TKEFLK(I)),
c$$$     &                    SNGL (WTFLK(I)), SNGL (XFLK (I)),
c$$$     &                    SNGL (YFLK (I)), SNGL (ZFLK (I)),
c$$$     &                    SNGL (TXFLK(I)), SNGL (TYFLK(I)),
c$$$     &                    SNGL (TZFLK(I)), I = 1, NPFLKA )
c$$$*  |
c$$$*  +-------------------------------------------------------------------*
c$$$*  |  Patch for heavy ions: it works only for 1 source particle on
c$$$*  |  the stack for the time being
c$$$      ELSE IF ( ABS (ILOFLK (NPFLKA)) .GE. 10000 ) THEN
c$$$         IONID = ILOFLK (NPFLKA)
c$$$         CALL DCDION ( IONID )
c$$$         WRITE (IODRAW) ( IONID,SNGL(TKEFLK(I)+AMNHEA(-IONID)),
c$$$     &                    SNGL (WTFLK(I)), SNGL (XFLK (I)),
c$$$     &                    SNGL (YFLK (I)), SNGL (ZFLK (I)),
c$$$     &                    SNGL (TXFLK(I)), SNGL (TYFLK(I)),
c$$$     &                    SNGL (TZFLK(I)), I = 1, NPFLKA )
c$$$*  |
c$$$*  +-------------------------------------------------------------------*
c$$$*  |  Patch for heavy ions: ???
c$$$      ELSE IF ( ILOFLK (NPFLKA) .LT. -6 ) THEN
c$$$         WRITE (IODRAW) ( IONID,SNGL(TKEFLK(I)+AMNHEA(-ILOFLK(NPFLKA))),
c$$$     &                    SNGL (WTFLK(I)), SNGL (XFLK (I)),
c$$$     &                    SNGL (YFLK (I)), SNGL (ZFLK (I)),
c$$$     &                    SNGL (TXFLK(I)), SNGL (TYFLK(I)),
c$$$     &                    SNGL (TZFLK(I)), I = 1, NPFLKA )
c$$$*  |
c$$$*  +-------------------------------------------------------------------*
c$$$*  |
c$$$      ELSE
c$$$         WRITE (IODRAW) ( ILOFLK(I), SNGL (TKEFLK(I)+AM(ILOFLK(I))),
c$$$     &                    SNGL (WTFLK(I)), SNGL (XFLK (I)),
c$$$     &                    SNGL (YFLK (I)), SNGL (ZFLK (I)),
c$$$     &                    SNGL (TXFLK(I)), SNGL (TYFLK(I)),
c$$$     &                    SNGL (TZFLK(I)), I = 1, NPFLKA )
c$$$      END IF
c$$$*  |
*  +-------------------------------------------------------------------*
      RETURN
*
*======================================================================*
*                                                                      *
*     USer dependent DRAWing:                                          *
*                                                                      *
*     Icode = 10x: call from Kaskad                                    *
*             100: elastic   interaction secondaries                   *
*             101: inelastic interaction secondaries                   *
*             102: particle decay  secondaries                         *
*             103: delta ray  generation secondaries                   *
*             104: pair production secondaries                         *
*             105: bremsstrahlung  secondaries                         *
*             110: radioactive decay products                          *
*     Icode = 20x: call from Emfsco                                    *
*             208: bremsstrahlung secondaries                          *
*             210: Moller secondaries                                  *
*             212: Bhabha secondaries                                  *
*             214: in-flight annihilation secondaries                  *
*             215: annihilation at rest   secondaries                  *
*             217: pair production        secondaries                  *
*             219: Compton scattering     secondaries                  *
*             221: photoelectric          secondaries                  *
*             225: Rayleigh scattering    secondaries                  *
*             237: mu pair     production secondaries                  *
*     Icode = 30x: call from Kasneu                                    *
*             300: interaction secondaries                             *
*     Icode = 40x: call from Kashea                                    *
*             400: delta ray  generation secondaries                   *
*  For all interactions secondaries are put on GENSTK common (kp=1,np) *
*  but for KASHEA delta ray generation where only the secondary elec-  *
*  tron is present and stacked on FLKSTK common for kp=npflka          *
*                                                                      *
*======================================================================*
*
      ENTRY USDRAW ( ICODE, MREG, XSCO, YSCO, ZSCO )
      IF ( .NOT. LFCOPE2 ) THEN
         LFCOPE2 = .TRUE.
         WRITE(LUNOUT,*) 'MGDRAW: dump neutrons for photoelectric int.'
      END IF

*     select photonuclear interaction
      IF ( ICODE.EQ.101 .AND. JTRACK.EQ.7 ) THEN

         N = 0
         DO 10 IP = 1, NP
*     check that at least a neutron is among the daughter
            IF ( KPART(IP) .EQ. 8 ) N = N + 1
 10      CONTINUE

         IF (N .GT. 0) THEN
            WRITE (70,*)  "NCASE, ATRACK, N_neutrons", NCASE, ATRACK, N
*     store time of the photonuclear interaction
            T0 = ATRACK
         END IF

      END IF
* No output by default:
      RETURN
*=== End of subrutine Mgdraw ==========================================*
      END

